
<!DOCTYPE html>
<html ng-app="Static">
<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <title>Learning Assemble, Step 1 - Hello, Assemble! | James Wing</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Part of a series exploring the Assemble static web site framework for Node.js" />

    

<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.1.0/css/font-awesome.min.css"/>

<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.5/css/bootstrap.min.css" />



<link rel="stylesheet" type="text/css" href="../assets/css/compiled/site.css">



<!--<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/8.6/styles/default.min.css">-->


<link href="../assets/prism/prism.css" rel="stylesheet" />

<!--[if lt IE 9]>
<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
<![endif]-->

<script src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>


</head>
<body id="blogpost" ng-controller="BaseController">



<header class="navbar navbar-inverse normal" role="banner">
    <div class="navbar-container">
        <div class="navbar-header">
            <button class="navbar-toggle" type="button" data-toggle="collapse" data-target=".bs-navbar-collapse">
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="/index.html" class="navbar-brand">James Wing</a>
        </div>
        <nav class="collapse navbar-collapse bs-navbar-collapse" role="navigation">
            <ul class="nav navbar-nav navbar-right">
                

<li><a href="/index.html">Blog</a></li>
<li><a href="/about.html">About</a></li>


            </ul>
        </nav>
    </div>
</header>



<div class="layout-sidebar">
    <div class="row">
        <div class="col-sm-12 col-md-9 col-lg-8">
            

<div class="blogpost-wrapper">
    

    <div class="row">
        <div class="col-md-10 col-lg-10 post">
            <h1 class="title">
                <a href="">Learning Assemble, Step 1 - Hello, Assemble!</a>
            </h1>
            <!--<div class="author">-->
                <!---->
                <!---->
                <!---->
                <!--2014-10-22 by James Wing-->
            <!--</div>-->
            <div class="date">
                2014-10-22
            </div>

            

            <div class="content">

                
                    <p>I have recently been building static page generators to build landing pages, including the current
<a href="http://www.batchiq.com">BatchIQ.com</a> site.</p>
<p>My tool of choice so far has been <a href="http://assemble.io/">Assemble</a>.  I like Assemble&#x27;s integration as part of a
Grunt workflow, fairly rich feature set, Handlebars templates, and flexibility of output.
However, I&#x27;ve also had my share of thrills and spills figuring out how it does and doesn&#x27;t work.</p>
<p>I started by using boilerplate projects such as <a href="https://github.com/assemble/boilerplate">assemble-boilerplate</a>,
<a href="https://github.com/ghost-town/grunt-init-assemble">grunt-init-assemble</a>,
<a href="https://github.com/upstage/assemble-blog-theme">assemble-blog-theme</a>,
and then trying to understand how and why they work.  While they certainly do work and I can customize them,
each seemed to approach the static site problem slightly differently, and their complexity made it hard to
distill fundamental lessons about Assemble.  But just accepting a complicated configuration of script, YAML,
and Handlebars templates as &quot;black magic&quot; didn&#x27;t sit well with me.</p>
<p>In contrast, I was inspired and informed by Andi Smith&#x27;s
<a href="http://www.andismith.com/blog/2014/02/getting-started-with-assemble/">Getting Started with Assemble</a>
articles, especially his approach of skipping the boilerplate and starting from scratch.  It can be easier
to learn in isolated cases.  So I have decided to do the same, in perhaps more tedious detail,
and share the results.</p>

                    <p>As a first step, I tried to create the most minimal &quot;Hello, Assemble&quot; project that I could, to get a feel for the
base essence of it.  I installed Grunt and Assemble, configured a single template for Assemble to process,
and built out the template.</p>
<p>You can most easily see what this means by looking at the Gruntfile:</p>
<pre><code class="language-javascript">module.exports = <span class="function"><span class="keyword">function</span> <span class="params">(grunt)</span> {</span>
    grunt.initConfig({
        assemble: {
            hello: {
                files: {
                    <span class="string">'output/'</span>: [<span class="string">'index.hbs'</span>]
                }
            }
        }
    });
    grunt.loadNpmTasks(<span class="string">'assemble'</span>);
};</code></pre>
<p>Yes, that&#39;s the entire Gruntfile.  I tried cutting out the target &quot;hello&quot;, just to be thorough in my investigation,
but Assemble doesn&#39;t work without it.  The most basic feature of Assemble is processing Handlebars template files
from source to destination.  In this case, I have only a simple file with just enough action to convince us that
Assemble had processed the template.</p>
<pre><code class="language-markup">---
title: &quot;Hello, Assemble!&quot;
---
&lt;!DOCTYPE html&gt;
&lt;html&gt;
    &lt;head&gt;
        &lt;title&gt;Learning Assemble, Step 1 - Hello, Assemble!&lt;/title&gt;
    &lt;/head&gt;
    &lt;body&gt;
        &lt;h1&gt;Learning Assemble, Step 1 - Hello, Assemble!&lt;/h1&gt;
    &lt;/body&gt;
&lt;/html&gt;</code></pre>
<p>The non-html markup at the top of the file is YAML data associated with the page.  In Assemble terminology,
this is &quot;front-matter&quot;.  Every page has data associated with it both for the mechanics of processing
(input and output file names, formats, etc.) and for content (custom data like our title).</p>
<p>Run <code>grunt assemble</code>, and it works!  The output lists the templates processed:</p>
<pre><code>$ grunt assemble
Running &quot;assemble:hello&quot; (assemble) task
Assembling output/index.html OK
&gt;&gt; 1 pages assembled.

Done, without errors.</code></pre>
<p>And the output index.html file proves that the template was really processed:</p>
<pre><code class="language-markup">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
    &lt;title&gt;Hello, Assemble!&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;h1&gt;Hello, Assemble!&lt;/h1&gt;
&lt;/body&gt;
&lt;/html&gt;</code></pre>
<p>I&#39;m sure you are not impressed by the rich feature set, but I hope you get the point that you don&#39;t need a huge
boilerplate project to get started with Assemble.  It works just fine with as little as a single template and the
default options.</p>
<p>In the next post, we&#39;ll start adding in common Assemble project options and structure towards something more
practical and realistic.</p>
<p>For the code, please see the <a href="https://github.com/jvwing/learning-assemble">learning-assemble</a> repository on GitHub.
The branch <a href="https://github.com/jvwing/learning-assemble/tree/step01-hello-assemble">step01-hello-assemble</a>
contains the code from this post.</p>

                

                
                    
                
                    
                        <div class="blog-post-next">
                            Next:
                            <a href="/learning-assemble/step-2-basic-templating.html">
                                Learning Assemble, Step 2 - Basic Templating <i class="fa fa-lg fa-arrow-right"></i>
                            </a>
                        </div>
                    
                
                    
                
                    
                
                    
                
                    
                
                    
                
                    
                
                    
                
                    
                
                    
                
                    
                

            </div>

            <div class="share">
                <a href="https://twitter.com/share" class="twitter-share-button" data-text="Learning Assemble, Step 1 - Hello, Assemble!" data-via="jvwing" data-size="large">Tweet</a>
                <script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
            </div>

            <hr/>
            <div class="other-posts">
                <h4>You might also enjoy:</h4>
                <ul>
                    
                        <li><a href="/learning-assemble/step-1-hello-assemble.html">Learning Assemble, Step 1 - Hello, Assemble!</a></li>
                    
                        <li><a href="/learning-assemble/step-2-basic-templating.html">Learning Assemble, Step 2 - Basic Templating</a></li>
                    
                        <li><a href="/learning-assemble/step-3-grunt-workflow.html">Learning Assemble, Step 3 - Grunt Workflow</a></li>
                    
                        <li><a href="/learning-assemble/step-4-data.html">Learning Assemble, Step 4 - Data</a></li>
                    
                        <li><a href="/learning-assemble/step-5-page-navigation.html">Learning Assemble, Step 5 - Page Navigation</a></li>
                    
                        <li><a href="/learning-assemble/step-6-blogging-with-markdown.html">Learning Assemble, Step 6 - Blogging with Markdown</a></li>
                    
                        <li><a href="/learning-assemble/step-7-custom-handlebars-helpers.html">Learning Assemble, Step 7 - Custom Handlebars Helpers</a></li>
                    
                        <li><a href="/learning-assemble/step-8-debugging-assemble.html">Learning Assemble, Step 8 - Debugging Assemble</a></li>
                    
                        <li><a href="/learning-assemble/step-9-sitemap.html">Learning Assemble, Step 9 - Sitemap</a></li>
                    
                        <li><a href="/learning-assemble/step-10-pages-from-data.html">Learning Assemble, Step 10 - Pages from Data</a></li>
                    
                        <li><a href="/learning-assemble/step-11-more-navigation.html">Learning Assemble, Step 11 - More Navigation</a></li>
                    
                        <li><a href="/learning-assemble/step-12-navigation-helper.html">Learning Assemble, Step 12 - Navigation Helper</a></li>
                    
                </ul>
            </div>

            <div class="comments">
                <div id="disqus_thread"></div>
<script type="text/javascript">
    /* * * CONFIGURATION VARIABLES * * */
    var disqus_shortname = 'jameswingnet';

    /* * * DON'T EDIT BELOW THIS LINE * * */
    (function() {
        var dsq = document.createElement('script'); dsq.type = 'text/javascript'; dsq.async = true;
        dsq.src = '//' + disqus_shortname + '.disqus.com/embed.js';
        (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(dsq);
    })();
</script>
<noscript>Please enable JavaScript to view the <a href="https://disqus.com/?ref_noscript" rel="nofollow">comments powered by Disqus.</a></noscript>
            </div>

        </div>

    </div>

</div>

        </div>
        <div class="col-md-3 col-lg-4 sidebar">
            <div class="posts-list-brief">
    <h3 class="sidebar-heading">Recent</h3>
    <ul>
        
            
        
            
                
                    <li>
                        
                            <a href="/aws/query-cloudtrail-events-with-athena.html">Query CloudTrail Events with Athena</a>
                        
                    </li>
                
                    <li>
                        
                            <a href="/nifi/nifi-internal-fields.html">Hidden Fields in Apache NiFi FlowFiles</a>
                        
                    </li>
                
                    <li>
                        
                            <a href="/nifi/first-look-at-apache-nifi.html">First Look at Apache NiFi</a>
                        
                    </li>
                
                    <li>
                        
                            <a href="/monitoring/monitoring-advice-distilled.html">Monitoring Advice Distilled</a>
                        
                    </li>
                
                    <li>
                        
                            <a href="/aws/using-codecommit-and-git-credentials.html">Using CodeCommit and GitHub Credential Helpers</a>
                        
                    </li>
                
            
        
            
        
            
        
            
        
            
        
    </ul>
</div>
            <hr/>
            <div class="ads">
    <!--<h3 class="sidebar-heading">Featured</h3>-->
    <div class="ad">
        <a href="http://prontolyzer.jameswing.net/">
            <img class="thumbnail" src="/assets/ads/prontolyzer-thumb.png" />
            <h4 class="title">Prontolyzer</h4>
            <p class="description">
                Interactive mapping and exploration of bike trip data for the 2015 Pronto Cycle Share Data Challenge.
                
            </p>
        </a>
    </div>
    <hr/>
    <div class="ad">
        <a href="/troubleshooting-chart/introducing-the-troubleshooting-chart.html">
            <img class="thumbnail" src="/assets/posts/troubleshooting-chart/troubleshootingchartannotated-thumbnail.png" />
            <h4 class="title">The Troubleshooting Chart</h4>
            <p class="description">
                Level up your troubleshooting with simple data analysis and visualizations.
                A thrill-ride for Ops types.
            </p>
        </a>
    </div>
</div>
        </div>
    </div>
</div>




<div id="footer">
    <div class="container">
        <div class="row">
            <div class="col-sm-6 copyright">
                © 2014-2017 James Wing. All Rights Reserved.
            </div>
            <div class="col-sm-6 menu">
                <ul>
                    

<li><a href="/index.html">Blog</a></li>
<li><a href="/about.html">About</a></li>


                </ul>
            </div>
        </div>
    </div>
</div>






<script src="//cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.5/js/bootstrap.min.js"></script>

<script>
    (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
        (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
            m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
    })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
    var gaId = 'UA-6573';
    gaId += '6738-1';
    ga('create', gaId, 'auto');
    ga('send', 'pageview');

</script>









<script src="../assets/prism/prism.js"></script>


</body>
</html>